/*
 * Exemplo de uso de memria "compartilhada".
 * Criao de um segmento em um nico processo e verificao de endereos.
 */ 
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define SHMSZ 27 /* Ser arredondado para um mltiplo de PAGE_SIZE */

char str_global[10];

int main() {
  int shmid;
  key_t key;
  char str_local[10];
  char *shm;
  int pagesize = getpagesize();
  
  /* Chave arbitrria para o segmento compartilhado */
  key = 5677;

  /* Criao do segmento de memria e obteno do seu identificador. */
  if ((shmid = shmget(key, SHMSZ, IPC_CREAT | 0666)) < 0) {
    perror("shmget");
    exit(1);
  }

  /* Segmento  associado ao espao de endereamento */
  if ((shm = shmat(shmid, NULL, 0)) == (char *) -1) {
    perror("shmat");
    exit(1);
  }

  printf("str_local  = %p\n", str_local);
  printf("shm        = %p\n", shm);  
  printf("str_global = %p\n", str_global);
  printf("main       = %p\n", (void*) main);


  printf("Tamanho em bytes de um endereo: %lu\n", sizeof(char*));
  printf("Tamanho em bytes de uma pgina: %d\n", pagesize);
  
  shm[pagesize - 1] = 0;
  shm[pagesize] = 0;
  shm[pagesize + 1] = 0;


  return 0;
}
